package com.jscape.inet.ssh.protocol.v2.messages;

import com.jscape.inet.ssh.protocol.messages.Message;
import com.jscape.util.net.connection.MessageConnection;

/**
 * @author Alex Usun
 */
public class SshMsgChannelOpenSession
        extends SshMsgChannelOpen<SshMsgChannelOpenSession.Handler> {

    public SshMsgChannelOpenSession(int senderChannel, long initialWindowSize, int maxPacketSize) {
        super(senderChannel, initialWindowSize, maxPacketSize);
    }

    @Override
    public Class handlerClass() {
        return Handler.class;
    }

    @Override
    public void accept(Handler handler, MessageConnection<Message> connection) {
        handler.handle(this, connection);
    }

    @Override
    public String toString() {
        return "SshMsgChannelOpenSession {"
                + "senderChannel=" + this.senderChannel
                + ", initialWindowSize=" + this.initialWindowSize
                + ", maxPacketSize=" + this.maxPacketSize
                + '}';
    }

    public interface Handler
            extends Message.HandlerBase {

        void handle(SshMsgChannelOpenSession message, MessageConnection<Message> connection);

    }
}
